



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Hibernate的三种状态</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Hibernate的三种状态</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 19:03:30 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>&nbsp;Hibernate的对象有3种状态，分别为：瞬时态(Transient)、 持久态(Persistent)、脱管态(Detached)。处于持久态的对象也称为PO(Persistence Object)，瞬时对象和脱管对象也称为VO（Value Object）。&nbsp;</strong></p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20141217150548796?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQva3BjaGVuXzA1MDg=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<h1>瞬时态&nbsp;<strong>Transient</strong></h1>
<p>由new命令开辟内存空间的java对象，</p>
<p>eg. Person person = new Person("xxx", "xx");</p>
<p>如果没有变量对该对象进行引用，它将被java虚拟机回收。</p>
<p>瞬时对象在内存孤立存在，它是携带信息的载体，不和数据库的数据有任何关联关系，在Hibernate中，可通过session的save()或saveOrUpdate()方法将瞬时对象与数据库相关联，并将数据对应的插入数据库中，此时该瞬时对象转变成持久化对象。</p>
<h1>持久态&nbsp;<strong>Persistent</strong></h1>
<p>处于该状态的对象在数据库中具有对应的记录，并拥有一个持久化标识。如果是用hibernate的delete()方法，对应的持久对象就变成瞬时对象，因数据库中的对应数据已被删除，该对象不再与数据库的记录关联。</p>
<p>当一个session执行close()或clear()、evict()之后，持久对象变成脱管对象，此时持久对象会变成脱管对象，此时该对象虽然具有数据库识别值，但它已不在HIbernate持久层的管理之下。</p>
<p>持久对象具有如下特点：</p>
<p>1. 和session实例关联；</p>
<p>2. 在数据库中有与之关联的记录。</p>
<h1>脱管态&nbsp;<strong>Detached</strong></h1>
<p>当与某持久对象关联的session被关闭后，该持久对象转变为脱管对象。当脱管对象被重新关联到session上时，并再次转变成持久对象。</p>
<p>脱管对象拥有数据库的识别值，可通过update()、saveOrUpdate()等方法，转变成持久对象。</p>
<p>脱管对象具有如下特点：</p>
<p>1. 本质上与瞬时对象相同，在没有任何变量引用它时，JVM会在适当的时候将它回收；</p>
<p>2.&nbsp;&nbsp; 比瞬时对象多了一个数据库记录标识值。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8km259j.html">&lbrack;数据结构&rsqb;&mdash;&mdash;二叉树（Binary Tree）、二叉搜索树（Binary Search Tree）及其衍生算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8okx4p9.html">easyui textbox 添加 onblur 失去焦点事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/390e1p4q.html">OC &mdash; &lpar;Foundation框架-NSDate&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn56rgq.html">windows内核编程 白话设备栈</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j75ge9.html">Response&period;Clear&lpar;&rpar;和Response&period;ClearContent&lpar;&rpar;区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2lk1w9.html">javascript复习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xmye68.html">POJ 1269 Intersecting Lines（直线相交判断，求交点）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e12y5e9.html">android 监听去电实现ip拨号 广播接收者</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yod75q.html">Java Socket 编程指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydejm2q.html">Git跨平台中文乱码临时解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdxd4y9.html">JavaScript 基本类型值-Undefined、Null、Boolean</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mek7z0q.html">ifconfig命令--查看、配置、启用或禁用网络接口的工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1711mq.html">MySQL数据库简识</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oje17eq.html">MongoDB 中数据的替换方法实现 --类Replace&lpar;&rpar;函数功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/960mkj39.html">【数学建模】day07-数理统计II</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv2m4g8.html">【洛谷P2042】维护数列</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w7ovzq.html">chmod chown</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjd0m69.html">oracle查锁及解锁命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyynjemq.html">Hive SQL  grouping sets 用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/960vwjn9.html">报错，但不影响运行ERROR&colon; JDWP Unable to get JNI 1&period;2 environment&comma; jvm-&amp;gt&semi;GetEnv&lpar;&rpar; return code &equals; -2</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/2q7j2l1q.html">Linux 下从头再走 GTK&plus;-3&period;0 &lpar;四&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jxd3gq.html">MMORPG大型游戏设计与开发（概述）updated</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jxdy4q.html">Navicat for MySQL连接MYSQL出错&comma;错误代码1045的解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7jjzgq.html">MyBatis使用总结&plus;整合Spring</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gxxpzq.html">Machine Learning Algorithms Study Notes&lpar;1&rpar;--Introduction</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kdl559.html">记录mysql的具体操作明细</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnl6jx9.html">java 25 - 3 网络编程之 Socket套接字</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mx4m69.html">5&period;Transact-SQL编程</a>
			</li>
						<li><a href="https://www.batexi.com/a/r9361nn9.html">css3属性选择器</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o2r3p9.html">window&period;execScript的兼容性写法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
